import java.awt.*;
import java.util.*;

public class BM extends KMP
{
	BM(){
	}
	
	String text = "";
	String pattern = "";
	public void start(String entry){
		//text = textEntry.getText();
		pattern = entry;
	
		if (pattern.equals("")){
			pattern = set_random(16);
		}
		
		init();
		
	}
	public String set_random(int n){
		String string = "";
		for(int i=0; i<n; i++){
			char c =  (char) ('a' + ((int) 4*Math.random()));
			string += c;
		}
		return string;
	}
	
	
	Font font = new Font("Courier New",  Font.BOLD, 40);
	Font font2 = new Font("Helvetica",  Font.PLAIN, 30);
	public void paint(Graphics g){
		g.setFont(font);
		//drawText(text, g, 10, 60);
		g.drawString("pattern:",10, 60);
		drawText(pattern, g, 250, 60);
		
		
		g.setFont(font2);
		g.drawString("j:",10, 30);
		g.drawString("s:",10, 100);
		g.drawString("next:",10, 140);
		for(int i=0; i<next.length-1; i++){
			g.drawString(""+(i+1),   250+dx*i, 30);	
			g.drawString(""+ss[i+1],   250+dx*i, 100);	
			g.drawString(""+next[i+1], 250+dx*i, 140);	
		}
	}
	public void drawText(String string, Graphics g, int x, int y){
		for(int i=0; i<string.length(); i++){
			g.drawString(""+string.charAt(i), x+dx*i, y);
		}	
	}
	
	
	
	
	
	
	
	// Boyer-Moore
	int[] next;
	int[] ss;
	public void init(){
		int m = pattern.length();

		char[] _pattern = new char[m+1];
		for(int i=0; i<m; i++)
			_pattern[i+1] = pattern.charAt(i);
		_pattern[0] = (char) 0;
		
		next = new int[m+1];
		ss  = new int[m+1];
		for(int s=m; s>=1; s--){
			int j = m;	
			while (_pattern[j-s] == _pattern[j])
				j--;
			if (j>s) {
				next[j] = m-j+s;
				ss[j] = s;
			}
			else
				while (j>0){
					next[j] = m-j+s;
					ss[j] = s;
					j--;
				}
		}
	}
	
}
